#include "TimerInt.h"

void TIM7_Int_Init(void)
{
    TIM_TimeBaseInitTypeDef TIM_TimeBaseInitStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM7, ENABLE); ///使能TIM3时钟

    TIM_TimeBaseInitStructure.TIM_Period = 10000; 	//自动重装载值
    TIM_TimeBaseInitStructure.TIM_Prescaler = 10000; //定时器分频
    TIM_TimeBaseInitStructure.TIM_CounterMode = TIM_CounterMode_Up; //向上计数模式
    TIM_TimeBaseInitStructure.TIM_ClockDivision = TIM_CKD_DIV1;

    TIM_TimeBaseInit(TIM7, &TIM_TimeBaseInitStructure); //初始化TIM3

    TIM_ITConfig(TIM7, TIM_IT_Update, ENABLE); //允许定时器3更新中断
    TIM_Cmd(TIM7, ENABLE); //使能定时器3

    NVIC_InitStructure.NVIC_IRQChannel = TIM7_IRQn; //定时器3中断
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0x01; //抢占优先级1
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0x03; //子优先级3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

}

//定时器3中断服务函数
void TIM7_IRQHandler(void)
{
    if(TIM_GetITStatus(TIM7, TIM_IT_Update) == SET) //溢出中断
    {

    }
    TIM_ClearITPendingBit(TIM7, TIM_IT_Update); //清除中断标志位
}
